<?php
if(!class_exists('Sidebar_domination')){
	die('No direct access allowed.');
}

class Sidebar_domination_admin extends Sidebar_domination {

	function Sidebar_domination_Admin(){
		parent::Sidebar_domination();
		add_action('admin_menu',array(&$this,'admin_menu'));
	}
	
	function admin_menu(){
		$page = add_options_page('Sidebar Domination', 'Sidebar Domination', 'manage_options', 'sidebar-domination', array(&$this,'options_page'));
		add_action('admin_print_styles-'.$page, array(&$this, 'admin_styles'));
	}
	
	function load_settings_admin(){
		$this->data['template'] = $this->get_option('template', false);
		$this->data['fields'] = $this->get_option('fields', false);
		$this->data['affiliate'] = $this->get_option('affiliate', false);
		$this->data['mailing'] = $this->get_option('mailing' ,false);
		$this->load_admin_template('admin');
	}
	
	function options_page(){
		if(!$this->option('installed')){  
			$this->update('installed', 'Y');
		} else {
			if($this->option('installed') == 'Y'){
				if(!isset($_POST['update'])){
					$this->themeslist = $this->get_themes();
					$this->load_settings_admin();
				}
			}else{
				echo 'There was a problem, try again';
			}
		}
		if(isset($_POST['update'])){
			return $this->save_admin_options();
		}

	}
	
	function get_themes(){

		if(count($this->themes) == 0){
			$themes = $this->get_file_list($this->theme_path,true);
			$this->themes = array();
			foreach($themes as $t){
				if($t = $this->get_theme_info($t))
					$this->themes[] = $t;
			}
			//$this->themes,array(&$this,'sort_array');
		}
		return $this->themes;
	}
	
	function get_theme_info($t){

		$files = $this->get_file_list($this->theme_path.$t);
		if(in_array('theme.txt',$files)){
			$template_data = implode( '', file( $this->theme_path.$t.'/theme.txt' ));
			$name = '';
			$opts = array();
			if(preg_match('|Template Name:(.*)$|mi', $template_data, $name)){
				$opts['name'] = _cleanup_header_comment($name[1]);
				$opts['center'] = 'N';
				if(preg_match( '|Center:(.*)$|mi', $template_data, $size))
					$opts['center'] = _cleanup_header_comment($size[1]);
				if(preg_match( '|Preview Size:(.*)$|mi', $template_data, $size))
					$opts['size'] = array_filter(explode('x',_cleanup_header_comment($size[1])));
				$opts['ext'] = 'png';
				if(preg_match( '|Preview Ext:(.*)$|mi', $template_data, $ext))
					$opts['ext'] = _cleanup_header_comment($ext[1]);
				if(preg_match( '|Colors:(.*)$|mi', $template_data, $color)){
					$opts['colors'] = $this->color_opts($t,$opts['ext'],array_filter(explode(' | ',_cleanup_header_comment($color[1]))));
				} else {
					if(file_exists($this->theme_path.$t.'/preview.'.$opts['ext']))
						$opts['img'] = $t.'/preview.'.$opts['ext'];
				}
				if(preg_match('|Button Colors:(.*)$|mi',$template_data, $colors))
					$opts['button_colors'] = $this->button_colors($t,array_filter(explode('|',_cleanup_header_comment($colors[1]))));
				if(preg_match( '|List Items:(.*)$|mi', $template_data, $list))
					$opts['list'] = intval(_cleanup_header_comment($list[1]));
				if(preg_match( '|Fields:(.*)$|mi', $template_data, $fields))
					$opts['fields'] = $this->field_opts(array_filter(explode('|',_cleanup_header_comment($fields[1]))));
				$opts['theme'] = $t;
				return $opts;
			}
		}
		return false;
	}
	
	function save_admin_options(){
		$this->save_template();
		$this->save_fields();
		$this->save_affiliate();
		$this->save_mailing();
		
		$this->themeslist = $this->get_themes();
		$this->load_settings_admin();
	}
	
	function save_affiliate(){
		$arr = array();
		if($_POST['sd']['affiliate']['link'] != ""){
			$sd = $_POST['sd']['affiliate'];
			$arr = array('link' => $sd['link'], 'url' => $sd['url']);
		}else{
			$arr = array('link' => 'PopUp Domination', 'url' => 'http://www.popupdomination.com');
		}
		$this->update('affiliate',serialize($arr));
	}
	
	function save_fields(){
		$arr = array();
		if(isset($_POST['sd']['fields'])){
			$sd = $_POST['sd']['fields'];
			$widthnum = strlen($sd['width']);
			if($widthnum > 1){$width = $sd['width'];}else{$width = '100%';}
			$arr = array('title' => $sd['title'], 'security' => $sd['security'], 'default' => array ( 'name' => $sd['default']['name'], 'email' => $sd['default']['email'] ), 'submit' => $sd['submit'], 'width' => $sd['width']);
		}
		$this->update('fields',serialize($arr));
	}
	
	function save_mailing(){
		$arr = array();
		if(isset($_POST['sd']['mailing'])){
			$sd = $_POST['sd']['mailing'];
			$arr = array('code' => $sd['code'], 'newwindow' => $sd['newwindow'], 'disablename' => $sd['disablename'], 'nameinput' => $sd['form']['name'], 'emailinput' => $sd['form']['email'], 'action' => $sd['action']);
		}
		$this->update('mailing',serialize($arr));
	}
	
	function save_template(){
		$arr = array();
		if(isset($_POST['sd']['template']['theme'])){
			$sd = $_POST['sd']['template'];
			$arr = array('theme' => $sd['theme'], 'button-colour' => $sd['button'], 'colour' => $sd['colour-options']);
		}
		$this->update('template',serialize($arr));
	}
	
	function get_file_list($dir,$dirs=false,$types=array(),$natypes=array()){
		$t_dir = @opendir($dir);
		if(!$t_dir)
			return false;
		$na = array('','.','..');
		$files = array();
		while(($file = readdir($t_dir)) !== false){
			if(!in_array($file,$na)){
				if($dirs == true){
					if(is_dir($dir.$file))
						$files[] = $file;
				} else {
					if(!is_dir($dir.$file)){
						if($this->check_file_type($file,$types,$natypes))
							$files[] = $file;
					}
				}
			}
		}
		if($t_dir)
			@closedir($t_dir);
		return $files;
	}
	
	function color_opts($t,$ext,$colors=array()){
		if(is_array($colors) && count($colors) > 0){
			$arr = array();
			foreach($colors as $c){
				$tmp_arr = array();
				$c2 = explode('[',$c);
				$tmp_arr['name'] = $c2[0];
				$c2 = explode(']',$c2[1]);
				$info = array_filter(explode(':',$c2[0]));
				$file = $t.'/previews/'.$info[0].'.'.$ext;
				if(file_exists($this->theme_path.$file) && is_file($this->theme_path.$file)){
					$info[2] = $file;
				}
				$tmp_arr['info'] =  $info;
				$arr[] = $tmp_arr;
			}
			return $arr;
		}
		return false;
	}
	
	function button_colors($t,$colors=array()){
		if(is_array($colors) && count($colors) > 0){
			$arr = array();
			foreach($colors as $c){
				$tmp_arr = array();
				$c2 = explode('[',$c);
				$tmp_arr['name'] = $c2[0];
				$c2 = explode(']',$c2[1]);
				$tmp_arr['color_id'] = $c2[0];
				$arr[] = $tmp_arr;
			}
			//usort($arr,array(&$this,'sort_array'));
			return $arr;
		}
		return false;
	}
	
	function field_opts($fields=array()){
		if(is_array($fields) && count($fields) > 0){
			$arr = array();
			foreach($fields as $f){
				$tmp_arr = array();
				$f2 = explode('[',$f);
				$tmp_arr['name'] = $f2[0];
				$f2 = explode(']',$f2[1]);
				$f2 = array_filter(explode(',',$f2[0]));
				$tmp_arr['field_opts'] = array();
				foreach($f2 as $a => $b){
					$f3 = explode(':',$b);
					if(count($f3) > 1){
						$tmp_arr['field_opts'][$f3[0]] = $f3[1];
					}
				}
				$arr[] = $tmp_arr;
			}
			return $arr;
		}
		return false;
	}
	
	function admin_styles(){
		add_thickbox();
		wp_enqueue_style('sidebar_domination', $this->plugin_url.'css/admin.css');
		//wp_enqueue_style('sidebar_domination-editor', $this->plugin_url.'css/editor.css');
		if(($ins = $this->option('installed')) && $ins == 'Y'){
			wp_enqueue_script('sidebar_function_',$this->plugin_url.'js/admin.js',array('jquery'),'1.0');
		}
	}
	
}

$listeruption = new Sidebar_domination_Admin();